$(document).ready(function(){
	
	if(typeof demopage=='undefined') demopage=1;
	
	//START cloud			
	$('#mycloud').cloud({

		//all settings are optional, you can delete them or provide your values
	
		hwratio				: 1,		//height/width ratio
		enable				: true,		//enable effect on mouse move
		draggable			: true,		//enable mouse drag
		gravitydriven		: false,		//enable effect on mobile device movement
		template			: 1,		//number of template (0-10) or function
		maxspeed			: 400,		//maximum rotation speed
		attenuation			: 0.01,		//attenuation
		perspective			: 0.4,		//perspective koefficient
		sensitivityx		: (demopage==3)?0.1:0.07,		//if sensitivity=0 no effect will be applied
		sensitivityy		: (demopage==3)?0.1:0.07,		//negative values invert mouse			
		fadein				: 400,		//fadein on start (in ms)
		fog					: 0.3,		//fog index
		zsort				: true,		//sort by z
		fps					: 60,		//default fps limit
		fpsmobile			: 30,		//default fps limit on mobile devices
		scale				: 0.8,		//scale template
		imgscale			: 0.5,		//scale images (works only if they are direct children of cloud)
		onclick             : (demopage==3)?someFunction2:someFunction	//function to execute on tag click
	}); 

	
	
	
	$(".dropdown-menu li a").bind( "click", function(){
		var template=(this.href).split('#')[1];
		if(template=='custom') template=customTemplate;
		$('#vtemplate').html(this.innerHTML);
		$('#mycloud').cloud('option','template',template);
		//return false;
	});

	$(".ui-slider").bind( "slide", function(){
		var val=this.value
		
		if(this.id=='attenuation'){
			var vals=['no','slow','fast','very fast'];
			val=vals[Math.ceil(this.value*10*1.5)];
		}
		
		$( '#v'+this.id ).html(val);
		$('#mycloud').cloud('option',this.id ,this.value);
	}).trigger("slide");
	

	
	$("#styles a").bind( "click", function(){
		if($(this).hasClass('disabled')) return;
		
		var n=$(this).data('skin')*1.0;		
		$("#styles a").removeClass('disabled');			
		$(this).addClass('disabled');
		
		var tags='';
		
		
		if(n==3){
			for(var i=0;i<24;i++) tags+='<img src="img/dot.png">';
			$('#mycloud').cloud('option','onclick', someFunction);
			$("#imgscale").prop( "disabled", false);
		}else if(n==2){					
			for(var i=1;i<25;i++) tags+='<img class="img" data-onclick="'+i+'" src="img/small/'+i+'.jpg">';
			$('#mycloud').cloud('option','onclick', someFunction2);
			$("#imgscale").prop( "disabled", false);
		}else{
			txt=("Lorem ipsum dolor sit amet consectetur adipiscing elit Vestibulum vehicula elit id lorem pellentesque sed consequat neque rhoncus Cras tempor dui sit amet dictum").split(" ");			
			for(var i=0;i<24;i++) tags+='<div data-onclick="'+txt[i]+'">'+txt[i]+'</div>';
			$('#mycloud').cloud('option','onclick', someFunction);
			$("#imgscale").prop( "disabled", true);			
		}
		
		
		$('#mycloud').cloud('reinit',tags);
		
	});
	
	
	$('#vsensitivityy, #vsensitivityx').tooltip({title:'negative values = inverted mouse'});
	$('#vattenuation').tooltip({title:'attenuation on roll out'});
	$('#vfps').tooltip({title:'limit number of re-drawings (frames) per second'});
	$('#vperspective').tooltip({title:'negative values produce inverted perspective'});
	$('#vfpsmobile').tooltip({title:'limit number of re-drawings (frames) per second on mobile devices'});
	
	hide('play');
	
});



function customTemplate(i, n) {
	if(i>0.75*n){
		var x=(8*i/n-7)*16;
		return {x:x/2, y:-x/2, z:x};
	}
	
	var t=Math.PI*2*i/(0.75*(n+1));
	var temp=Math.sin(t);
	var x=16*temp*temp*temp;
	var y=13*Math.cos(t)-5*Math.cos(2*t)-2*Math.cos(3*t)-Math.cos(4*t);
	return {x:x, y:-y*0.8-2, z:0, v:0};		
};



function someFunction(v) {
	if(typeof v == 'undefined') v='tag';
	else v='"'+v+'"';
	alert('you clicked '+v);  //v = value of data-onclick attribute	(see below)
};

function someFunction2(v) {	
	//show modal window on tag click
	$.colorbox({href:"img/big/"+v+".jpg", opacity:0.5, scalePhotos:true, maxWidth:'90%', maxHeight:'90%', initialWidth:'50%'});	
};


function optionSwitch(optionName, optionValue){
	if(typeof optionValue == 'undefined'){
		optionValue=document.getElementById(optionName).checked;
	}
	$('#mycloud').cloud('option',optionName,optionValue);						
}


function changeTemplate(){
	var n=$('#mycloud').cloud('option','template');
	n=n>8?1:n+1;
	$('#mycloud').cloud('option','template',n);
}

function show(id){
	var ele = document.getElementById(id);
	ele.style.display = "block";
}
		
function hide(id){
	var ele = document.getElementById(id);
	if(ele != null) ele.style.display = "none";
}
